diff --git a/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java b/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
index 8678031b7..3145e9c03 100644
--- a/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
+++ b/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
@@ -7,7 +7,9 @@ import com.mojang.nbt.tags.Tag;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.settings.WorldConfiguration;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.util.Collection;
@@ -20,28 +22,43 @@ public class SpawnerConfig {
     public boolean allowHostile = true;
     private final Map<NamespaceID, Boolean> mobSpawnOverrides = new HashMap<>();
 
+    private @Nullable WorldConfiguration.ChangeListener changeListener;
+
+    public void setChangeListener(final @Nullable WorldConfiguration.ChangeListener changeListener) {
+        this.changeListener = changeListener;
+    }
+
+    private void notifyChange() {
+        if (this.changeListener != null) {
+            this.changeListener.onChanged();
+        }
+    }
+
     public boolean canPassiveSpawn(@NotNull World world) {
         return this.allowPassive;
     }
 
-    public void setPassiveSpawning(boolean flag) {
-        this.allowPassive = flag;
+    public void setPassiveSpawning(boolean allowPassive) {
+        this.allowPassive = allowPassive;
+        this.notifyChange();
     }
 
     public boolean canHostileSpawn(@NotNull World world) {
         return this.allowHostile && world.getDifficulty().canHostileMobsSpawn();
     }
 
-    public void setHostileSpawning(boolean flag) {
-        this.allowHostile = flag;
+    public void setHostileSpawning(boolean hostileSpawning) {
+        this.allowHostile = hostileSpawning;
+        this.notifyChange();
     }
 
     public boolean canMobSpawn(@NotNull NamespaceID mobID) {
         return this.mobSpawnOverrides.getOrDefault(mobID, true);
     }
 
-    public void setMobSpawn(@NotNull NamespaceID mobID, boolean flag) {
-        this.mobSpawnOverrides.put(mobID, flag);
+    public void setMobSpawn(@NotNull NamespaceID mobID, boolean enabled) {
+        this.mobSpawnOverrides.put(mobID, enabled);
+        this.notifyChange();
     }
 
     public void set(@NotNull SpawnerConfig config) {
@@ -50,6 +67,8 @@ public class SpawnerConfig {
 
         this.allowHostile = config.allowHostile;
         this.allowPassive = config.allowPassive;
+
+        this.notifyChange();
     }
 
     public Collection<Map.Entry<NamespaceID, Boolean>> getSpawnEntries() {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
index 3bb495e7c..7becac3cd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
@@ -40,7 +40,7 @@ public class IceFloeLargeFeature
         }
 
         final @NotNull WorldType worldType = world.getWorldType();
-        final int oceanY = worldType.getMinY() + worldType.getOceanY();
+        final int oceanY = worldType.getMinY(world) + worldType.getOceanY();
 
         final @NotNull TilePos tilePos = new TilePos();
         final @NotNull WorleyNoise.Result worleyResult = new WorleyNoise.Result();
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java
index e8b77ae80..e8edf3c8d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java
@@ -45,8 +45,8 @@ public abstract class ChunkFeatureDecorator
         final int worldX = chunkX * 16;
         final int worldZ = chunkZ * 16;
 
-        final int minY = this.world.getWorldType().getMinY();
-        final int maxY = this.world.getWorldType().getMaxY();
+        final int minY = this.world.getWorldType().getMinY(world);
+        final int maxY = this.world.getWorldType().getMaxY(world);
         final int rangeY = (maxY + 1) - minY;
 
         final @NotNull Random rand = new Random(this.world.getRandomSeed());
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
index f795cddc6..727182ed3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
@@ -66,6 +66,9 @@ public class ChunkGeneratorClassic
         int chunkX = chunk.pos.x;
         int chunkZ = chunk.pos.z;
 
+        final int minY = world.getWorldType().getMinY(world);
+        final int maxY = world.getWorldType().getMaxY(world);
+
         final float mod = 1.3F;
 
         final int[] heightMap = new int[Chunk.CHUNK_SIZE_X * Chunk.CHUNK_SIZE_Z];
@@ -108,15 +111,15 @@ public class ChunkGeneratorClassic
                 int newHeight;
                 final int val2 = (newHeight = newHeightMap[x + z * Chunk.CHUNK_SIZE_X] + this.world.getWorldType().getOceanY()) + val;
                 newHeightMap[x + z * Chunk.CHUNK_SIZE_X] = Math.max(newHeight, val2);
-                if (newHeightMap[x + z * Chunk.CHUNK_SIZE_X] > this.world.getWorldType().getMaxY() - 2) {
-                    newHeightMap[x + z * Chunk.CHUNK_SIZE_X] = this.world.getWorldType().getMaxY() - 2;
+                if (newHeightMap[x + z * Chunk.CHUNK_SIZE_X] > maxY - 2) {
+                    newHeightMap[x + z * Chunk.CHUNK_SIZE_X] = maxY - 2;
                 }
 
                 if (newHeightMap[x + z * Chunk.CHUNK_SIZE_X] < 1) {
                     newHeightMap[x + z * Chunk.CHUNK_SIZE_X] = 1;
                 }
 
-                for (int y = this.world.getWorldType().getMinY(); y < this.world.getWorldType().getMaxY(); y++) {
+                for (int y = minY; y < maxY; y++) {
                     final int index = Chunk.makeBlockIndex(x, y, z);
                     int blockID = 0;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
index e4ecc9a6a..b3e12b394 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
@@ -21,7 +21,10 @@ public abstract class TerrainGeneratorLerp
 
     @Override
     public @NotNull ChunkGeneratorResult generateTerrain(@NotNull Chunk chunk, double @NotNull [] densityMap) {
-        int terrainHeight = (this.world.getWorldType().getMaxY() + 1) - this.world.getWorldType().getMinY();
+        final int minY = world.getWorldType().getMinY(world);
+        final int maxY = world.getWorldType().getMaxY(world);
+
+        int terrainHeight = (maxY + 1) - minY;
 
         this.rand.setSeed((long) chunk.pos.x * 0x4F9939F508L + (long) chunk.pos.z * 0x1EF1565BD5L);
 
@@ -116,7 +119,7 @@ public abstract class TerrainGeneratorLerp
                             for (int zInBlob = 0; zInBlob < zBlocksPerBlob; zInBlob++) {
                                 // Determine the coordinates for the block within the blob.
                                 int blockX = xInBlob + blobX * xBlocksPerBlob;
-                                int blockY = yInBlob + blobY * yBlocksPerBlob + this.world.getWorldType().getMinY();
+                                int blockY = yInBlob + blobY * yBlocksPerBlob + minY;
                                 int blockZ = zInBlob + blobZ * zBlocksPerBlob;
 
                                 int id = getBlockAt(chunk, blockX, blockY, blockZ, zLerpDensity);
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
index 00b03069e..58e788487 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
@@ -29,7 +29,7 @@ public class DensityGeneratorDrift
 
     @Override
     public double @NotNull [] generateDensityMap(@NotNull Chunk chunk) {
-        int terrainHeight = (this.world.getWorldType().getMaxY() + 1) - this.world.getWorldType().getMinY();
+        int terrainHeight = (this.world.getWorldType().getMaxY(world) + 1) - this.world.getWorldType().getMinY(world);
 
         int xSize = 4 + 1;
         int ySize = (terrainHeight / 8) + 1;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
index f9a00f5d1..50646cf94 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
@@ -31,8 +31,8 @@ public class ChunkDecoratorNether
         int chunkX = chunk.pos.x;
         int chunkZ = chunk.pos.z;
 
-        int minY = this.world.getWorldType().getMinY();
-        int maxY = this.world.getWorldType().getMaxY();
+        int minY = this.world.getWorldType().getMinY(world);
+        int maxY = this.world.getWorldType().getMaxY(world);
         int rangeY = (maxY + 1) - minY;
 
         Random rand = new Random((long) chunkX * 0x4f9939f508L + (long) chunkZ * 0x1ef1565bd5L);
@@ -167,7 +167,7 @@ public class ChunkDecoratorNether
         }
 
         int oceanY = this.world.getWorldType().getOceanY();
-        int midY = oceanY + (this.world.getWorldType().getMaxY() - oceanY) / 2;
+        int midY = oceanY + (this.world.getWorldType().getMaxY(world) - oceanY) / 2;
         for (int dx = x + 8; dx < x + 8 + 16; dx++) {
             for (int dz = z + 8; dz < z + 8 + 16; dz++) {
                 int dy = midY;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
index cf29fbf42..5f991a5d2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
@@ -20,6 +20,14 @@ public class DensityGeneratorNether
         double[] generateDensityMap(Chunk chunk, int terrainHeight, int xSize, int ySize, int zSize, int x, int y, int z);
     }
 
+    public static class BiomeOverlapPair {
+        public boolean hasOverlap;
+        public Biome biomeA;
+        public Biome biomeB;
+        public float biomeAPercentage;
+        public float biomeBPercentage;
+    }
+
     private final @NotNull World world;
 
     private final @NotNull Noise3D minLimitNoise;
@@ -65,7 +73,7 @@ public class DensityGeneratorNether
     public double @NotNull [] generateDensityMap(@NotNull Chunk chunk) {
         WorldType worldType = this.world.getWorldType();
 
-        int terrainHeight = ((worldType.getMaxY() + 1) - worldType.getMinY());
+        int terrainHeight = ((worldType.getMaxY(world) + 1) - worldType.getMinY(world));
         int xSize = 4 + 1;
         int ySize = (terrainHeight / 8) + 1;
         int zSize = 4 + 1;
@@ -79,8 +87,7 @@ public class DensityGeneratorNether
         double[] densityMapArray = new double[xSize * ySize * zSize];
         Map<Biome, double[]> perBiomeDensityMaps = new HashMap<>();
 
-        BiomeProviderNether biomeProvider = (BiomeProviderNether) this.world.getBiomeProvider();
-        BiomeProviderNether.BiomeOverlapPair[] overlapPairs = new BiomeProviderNether.BiomeOverlapPair[xSize * zSize];
+        BiomeOverlapPair[] overlapPairs = new BiomeOverlapPair[xSize * zSize];
 
         // Cache density maps for biome(s)
         int xSizeScale = 16 / xSize;
@@ -89,8 +96,8 @@ public class DensityGeneratorNether
             for (int dz = 0; dz < zSize; dz++) {
                 int iz = dz * xSizeScale + xSizeScale / 2;
                 double temperature = chunk.temperature[ix * 16 + iz];
-                BiomeProviderNether.BiomeOverlapPair overlapPair = overlapPairs[dx * xSize + dz] = new BiomeProviderNether.BiomeOverlapPair();
-                biomeProvider.getOverlap(temperature, overlapPair);
+                BiomeOverlapPair overlapPair = overlapPairs[dx * xSize + dz] = new BiomeOverlapPair();
+                this.getOverlap(temperature, overlapPair);
 
                 if (!perBiomeDensityMaps.containsKey(overlapPair.biomeA)) {
                     perBiomeDensityMaps.put(overlapPair.biomeA, this.densityGeneratorMap.get(overlapPair.biomeA).generateDensityMap(chunk, (int) (terrainHeight * 0.75f), xSize, threeQuarterYSize, zSize, x, y, z));
@@ -106,7 +113,7 @@ public class DensityGeneratorNether
         // Merge density maps
         for (int dx = 0; dx < xSize; dx++) {
             for (int dz = 0; dz < zSize; dz++) {
-                BiomeProviderNether.BiomeOverlapPair overlapPair = overlapPairs[dx * xSize + dz];
+                BiomeOverlapPair overlapPair = overlapPairs[dx * xSize + dz];
                 double[] densityMapA = perBiomeDensityMaps.get(overlapPair.biomeA);
                 double[] densityMapB = null;
                 if (overlapPair.hasOverlap) {
@@ -768,5 +775,91 @@ public class DensityGeneratorNether
         return densityMapArray;
     }
 
+    public void getOverlap(double temperature, BiomeOverlapPair toUpdate) {
+        final float overlapAmount = 1f / (float)(BiomeProviderNether.BIOMES_ORDER.length * 4);
+
+        for (int i = 0; i < BiomeProviderNether.BIOMES_ORDER.length; i++) {
+            // The *strict* bounds of the biome, as used by this::lookupBiome()
+            final float minStrict = (1.0f / BiomeProviderNether.BIOMES_ORDER.length) * i;
+            final float maxStrict = (1.0f / BiomeProviderNether.BIOMES_ORDER.length) * (i + 1);
+            // The outer bounds of the biome, i.e. strict bounds plus overlap amount. If in this range, guaranteed overlap
+            final float minOuter = minStrict - overlapAmount;
+            final float maxOuter = maxStrict + overlapAmount;
+            // The inner bounds of the biome, i.e. strict bounds minus overlap amount. If in this range, guaranteed no overlap
+            final float minInner = minStrict + overlapAmount;
+            final float maxInner = maxStrict - overlapAmount;
+
+            // Edge cases
+            if ((i == 0 && temperature < minInner) ||
+                (i == BiomeProviderNether.BIOMES_ORDER.length - 1 && temperature >= maxInner)
+            ) {
+                toUpdate.hasOverlap = false;
+                toUpdate.biomeA = BiomeProviderNether.BIOMES_ORDER[i];
+                toUpdate.biomeAPercentage = 1.0f;
+                return;
+            }
+
+            // Check if in inner bounds
+            if (temperature >= minInner && temperature < maxInner) {
+                // In inner bounds - only one biome is present here
+                toUpdate.hasOverlap = false;
+                toUpdate.biomeA = BiomeProviderNether.BIOMES_ORDER[i];
+                toUpdate.biomeAPercentage = 1.0f;
+                return;
+            }
+
+            // Check if in outer bounds
+            if (temperature >= minOuter && temperature < maxOuter) {
+                // Check if in min outer bound
+                if (temperature < minInner) {
+                    toUpdate.hasOverlap = true;
+
+                    // Define biomes
+                    toUpdate.biomeA = BiomeProviderNether.BIOMES_ORDER[i - 1];
+                    toUpdate.biomeB = BiomeProviderNether.BIOMES_ORDER[i];
+
+                    // Define percentages
+                    final float range = minInner - minOuter;
+                    // minOuter <= temperature < minInner
+                    temperature -= minOuter; // 0 <= temperature < range
+                    temperature /= range; // 0 <= temperature < 1
+
+                    // Biome A goes to 0.0 as temperature goes to 1.0
+                    // Biome B goes to 1.0 as temperature goes to 1.0
+                    toUpdate.biomeAPercentage = 1.0f - (float) temperature;
+                    toUpdate.biomeBPercentage = (float) temperature;
+
+                    return;
+                }
+
+                // Check if in max outer bound
+                if (temperature >= maxInner) {
+                    toUpdate.hasOverlap = true;
+
+                    // Define biomes
+                    toUpdate.biomeA = BiomeProviderNether.BIOMES_ORDER[i];
+                    toUpdate.biomeB = BiomeProviderNether.BIOMES_ORDER[i + 1];
+
+                    // Define percentages
+                    final float range = maxOuter - maxInner;
+                    // maxInner <= temperature < maxOuter
+                    temperature -= maxInner; // 0 <= temperature < range
+                    temperature /= range; // 0 <= temperature < 1
+
+                    // Biome A goes to 0.0 as temperature goes to 1.0
+                    // Biome B goes to 1.0 as temperature goes to 1.0
+                    toUpdate.biomeAPercentage = 1.0f - (float) temperature;
+                    toUpdate.biomeBPercentage = (float) temperature;
 
+                    return;
+                }
+            }
+        }
+
+        // We should never get here!
+        toUpdate.hasOverlap = false;
+        toUpdate.biomeA = Biomes.NETHER_NETHER;
+        toUpdate.biomeAPercentage = 1.0f;
+        return;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
index 39d364b46..98a4889b0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
@@ -30,8 +30,8 @@ public class SurfaceGeneratorNether
     @Override
     public void generateSurface(@NotNull Chunk chunk, @NotNull ChunkGeneratorResult result) {
         int oceanY = this.world.getWorldType().getOceanY();
-        int minY = this.world.getWorldType().getMinY();
-        int maxY = this.world.getWorldType().getMaxY();
+        int minY = this.world.getWorldType().getMinY(world);
+        int maxY = this.world.getWorldType().getMaxY(world);
         int chunkX = chunk.pos.x;
         int chunkZ = chunk.pos.z;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
index 616e14710..1e165ed96 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
@@ -33,6 +33,8 @@ public class TerrainGeneratorNether
     private int lastChunkZ = Integer.MIN_VALUE;
     private final @NotNull Noise3D noise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(0L, 4, 0));
     private final double @NotNull [] cache = new double[Chunk.CHUNK_SIZE_X * Chunk.CHUNK_SIZE_Z * (Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y)];
+    private final int minY;
+    private final int maxY;
 
     public TerrainGeneratorNether(@NotNull World world) {
         super(world);
@@ -45,6 +47,9 @@ public class TerrainGeneratorNether
         this.fluidLookup.put(Biomes.NETHER_CRYSTAL_FOREST, Blocks.FLUID_WATER_STILL.id());
         this.fluidLookup.put(Biomes.NETHER_ASH_PLAINS, Blocks.OBSIDIAN.id());
         this.fluidLookup.put(Biomes.NETHER_BONEYARD, Blocks.COBBLE_NETHERRACK.id());
+
+        this.minY = world.getWorldType().getMinY(world);
+        this.maxY = world.getWorldType().getMaxY(world);
     }
 
     @Override
@@ -85,11 +90,11 @@ public class TerrainGeneratorNether
         }
 
         WorldType type = this.world.getWorldType();
-        int quarterHeight = type.getMaxY() / 4;
+        int quarterHeight = maxY / 4;
 
         if (y < quarterHeight) {
             return 0;
-        } else if (y >= type.getMaxY() - this.rand.nextInt(5)) {
+        } else if (y >= maxY - this.rand.nextInt(5)) {
             return Blocks.BEDROCK.id();
         }
 //        else if (y >= quarterHeight - rand.nextInt(5) && y <= quarterHeight + 5 - rand.nextInt(5))
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index a0dbfe1c9..79128fb4b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -49,8 +49,8 @@ public class ChunkDecoratorOverworld
         int chunkX = chunk.pos.x;
         int chunkZ = chunk.pos.z;
 
-        int minY = this.world.getWorldType().getMinY();
-        int maxY = this.world.getWorldType().getMaxY();
+        int minY = this.world.getWorldType().getMinY(world);
+        int maxY = this.world.getWorldType().getMaxY(world);
         int rangeY = (maxY + 1) - minY;
 
         float oreHeightModifier = rangeY / 128f;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java
index 857db278a..87df20399 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java
@@ -151,7 +151,7 @@ public class DensityGeneratorOverworld
 
     @Override
     public double @NotNull [] generateDensityMap(@NotNull Chunk chunk) {
-        int terrainHeight = (this.world.getWorldType().getMaxY() + 1) - this.world.getWorldType().getMinY();
+        int terrainHeight = (this.world.getWorldType().getMaxY(world) + 1) - this.world.getWorldType().getMinY(world);
 
         int xSize = 4 + 1;
         int ySize = (terrainHeight / 8) + 1;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
index f9c10f834..07ecdc60e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
@@ -51,8 +51,8 @@ public class SurfaceGeneratorOverworld
     public void generateSurface(@NotNull Chunk chunk, @NotNull ChunkGeneratorResult result)
     {
         int oceanY = world.getWorldType().getOceanY();
-        int minY = world.getWorldType().getMinY();
-        int maxY = world.getWorldType().getMaxY();
+        int minY = world.getWorldType().getMinY(world);
+        int maxY = world.getWorldType().getMaxY(world);
         int terrainHeight = (maxY + 1) - minY;
         int chunkX = chunk.pos.x;
         int chunkZ = chunk.pos.z;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
index 62f3b3300..6c92100ee 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
@@ -14,12 +14,16 @@ public class TerrainGeneratorOverworld
     extends TerrainGeneratorLerp
 {
     private final DensityGenerator densityGenerator;
+    private final int minY;
+    private final int maxY;
 
     protected TerrainGeneratorOverworld(@NotNull World world, @NotNull DensityGenerator densityGenerator)
     {
         super(world);
 
         this.densityGenerator = densityGenerator;
+        this.minY = world.getWorldType().getMinY(world);
+        this.maxY = world.getWorldType().getMaxY(world);
     }
 
     public TerrainGeneratorOverworld(@NotNull World world)
@@ -32,7 +36,7 @@ public class TerrainGeneratorOverworld
     {
         WorldType type = this.world.getWorldType();
 
-        if (y <= type.getMinY() + this.rand.nextInt(5))
+        if (y <= minY + this.rand.nextInt(5))
         {
             return Blocks.BEDROCK.id();
         }
@@ -40,7 +44,7 @@ public class TerrainGeneratorOverworld
         {
             return type.getFillerBlockId();
         }
-        else if (y >= type.getMinY() && y < type.getMinY() + type.getOceanY())
+        else if (y >= minY && y < minY + type.getOceanY())
         {
             return type.getOceanBlockId();
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
index 9c3ce9602..f2353f4d7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
@@ -34,8 +34,8 @@ public class ChunkDecoratorOverworldB173
         final int x = chunk.pos.x;
         final int z = chunk.pos.z;
 
-        final int minY = this.world.getWorldType().getMinY();
-        final int maxY = this.world.getWorldType().getMaxY();
+        final int minY = this.world.getWorldType().getMinY(world);
+        final int maxY = this.world.getWorldType().getMaxY(world);
         final int rangeY = (maxY + 1) - minY;
 
         final int wx = x * 16;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkGeneratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkGeneratorOverworldB173.java
index 05bee89e7..316a71b26 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkGeneratorOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkGeneratorOverworldB173.java
@@ -14,7 +14,7 @@ public class ChunkGeneratorOverworldB173
             new ChunkDecoratorOverworldB173(world),
             new TerrainGeneratorOverworldB173(world),
             new SurfaceGeneratorOverworldB173(world),
-            new LargeFeature[]{new RetroCavesLargeFeature(world.getWorldType().getMinY(), world.getWorldType().getMaxY() + 1)}
+            new LargeFeature[]{new RetroCavesLargeFeature(world.getWorldType().getMinY(world), world.getWorldType().getMaxY(world) + 1)}
         );
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
index f1723b767..f65f70537 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
@@ -232,7 +232,7 @@ public class ChunkDecoratorOverworldHell
         final int worldX = x * 16;
         final int worldZ = z * 16;
 
-        final int minY = world.getWorldType().getMinY();
+        final int minY = world.getWorldType().getMinY(world);
 
         if (world.getBlockId(worldX, minY + world.getWorldType().getOceanY() - 1, worldZ) == world.getWorldType().getOceanBlockId()) {
             world.setBlockWithNotify(worldX, minY + world.getWorldType().getOceanY() - 1, worldZ, world.getWorldType().getOceanBlockId());
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
index dcc1771f2..f0810ce1f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
@@ -42,8 +42,8 @@ public class ChunkDecoratorOverworldRetro
         int chunkX = chunk.pos.x;
         int chunkZ = chunk.pos.z;
 
-        int minY = this.world.getWorldType().getMinY();
-        int maxY = this.world.getWorldType().getMaxY();
+        int minY = this.world.getWorldType().getMinY(world);
+        int maxY = this.world.getWorldType().getMaxY(world);
         int rangeY = (maxY + 1) - minY;
 
         BlockLogicSand.fallInstantly = true;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkGeneratorOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkGeneratorOverworldRetro.java
index f94ecf8f1..7c89dd75b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkGeneratorOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkGeneratorOverworldRetro.java
@@ -15,7 +15,7 @@ public class ChunkGeneratorOverworldRetro
             new ChunkDecoratorOverworldRetro(world),
             new TerrainGeneratorOverworldRetro(world),
             new SurfaceGeneratorOverworldRetro(world),
-            new LargeFeature[]{new RetroCavesLargeFeature(world.getWorldType().getMinY(), world.getWorldType().getMaxY() + 1)}
+            new LargeFeature[]{new RetroCavesLargeFeature(world.getWorldType().getMinY(world), world.getWorldType().getMaxY(world) + 1)}
         );
     }
 }
